#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <time.h>
#include <pwd.h>
#include <grp.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "define.h"
#include "lf.h"

extern char *search_notspace();

/* ////////////////////////////////////////////////////////////////////////////
////            function_draw                                              ////
////            ե󥯥󥭡ɽ                                   ////
//////////////////////////////////////////////////////////////////////////// */
void function_draw(char *msg[], unsigned long ncolor)
{
    int      i, n, w;
    static int offset = 1;
    static int xpos[] = { 8, 13, 18, 23, 31, 36, 41, 46, 54, 59, 64, 69 };
    n = 12;

    XSetForeground(pDisplay, gc, nfgcolor);
    XSetBackground(pDisplay, gc, ncolor);
    DrawImageText( 0, dis_msg, "Quit", ALL, offset);
    for ( w = i = 0 ; i < n ; i++, w++)
        DrawImageText(xpos[i], dis_msg, msg[w], ALL, offset);
}


/* ////////////////////////////////////////////////////////////////////////////
////            fkmsg_draw                                                 ////
////            ե󥯥󥭡ɽ                                   ////
//////////////////////////////////////////////////////////////////////////// */
void fkmsg_draw()
{
    static int offset = 1;

    XSetBackground(pDisplay, gc, px[0]);
    if ( shift_flag ) {
        XSetForeground(pDisplay, gc, nmgcolor2);
        DrawImageText(74, dis_msg, "Shift", ALL, offset);
        function_draw(skmsg, nmgcolor2);
    } else if ( ctrl_flag ) {
        XSetForeground(pDisplay, gc, nmgcolor3);
        DrawImageText(74, dis_msg, "Ctrl ", ALL, offset);
        function_draw(ckmsg, nmgcolor3);
    } else if ( alt_flag ) {
        XSetForeground(pDisplay, gc, nmgcolor4);
        DrawImageText(74, dis_msg, "Alt  ", ALL, offset);
        function_draw(akmsg, nmgcolor4);
    } else {
        Msg_Run(False);
        function_draw(fkmsg, nmgcolor1);
    }
}


/* ////////////////////////////////////////////////////////////////////////////
////            lf_out                                                     ////
////            ʬɽ                                           ////
//////////////////////////////////////////////////////////////////////////// */
void lf_out(n)
    int     n;
{
    struct group *gr , *getgrgid();
    struct passwd *pw , *getpwuid();
    struct lf_stat  *current_lf;
    struct tm *t;
    mode_t    fmode;
    int    i;
    char   perms[11];

    strcpy(perms, "?rwxrwxrwx");
    memset(outbuf, ' ', 80+fname_over);
    current_lf = (struct lf_stat *)pfile[n];
    if ( !tgz_flag )
      sprintf(outbuf + 26 + fname_over, "%3d ", current_lf->st_nlink);   /*  Link  */

    if ( tgz_flag == 2 && lzh_type ) {  /*  lzh  [MS-DOS] ... etc  */
      strcpy(outbuf + 30 + fname_over, lzh_permission_type);
    } else if ( tgz_flag == 3 ) {  /*  zip  */
    } else {
      fmode = current_lf->st_mode;                         /*  Permision  */
/*    printf("%o  %s\n", fmode, current_lf->st_name); */
      for ( i = 0 ; i < 9 ; i++) {
        if ( !((fmode >> i) & 1) )
	  perms[9-i] = '-';
      }
      if ( fmode & S_ISUID )
        perms[3] = 's';
      if ( fmode & S_ISGID )
        perms[6] = 's';
      if ( fmode & S_ISVTX )
        perms[9] = 't';
      
      fmode = fmode & S_IFMT;
      if ( fmode ==  S_IFDIR )
        perms[0] = 'd';
      else if ( fmode == S_IFCHR )
        perms[0] = 'c';
      else if ( fmode == S_IFBLK )
        perms[0] = 'b';
      else if ( fmode == S_IFREG )
        perms[0] = '-';
      else if ( fmode == S_IFLNK )
        perms[0] = 'l';
      else if ( fmode == S_IFSOCK )
        perms[0] = 's';
      else if ( fmode == S_IFIFO )
        perms[0] = 'p';
      strcpy(outbuf + 30+fname_over, perms);
    }
    sprintf(outbuf + 40+fname_over, "%9ld ", current_lf->st_size);  /* Size      */

    if ( tgz_flag ) {
      sprintf(outbuf + 50+fname_over, "%s", tgz_uid[current_lf->st_uid]);
    } else {
      if ((pw = getpwuid(current_lf->st_uid))) {           /* User Id   */
        sprintf(outbuf + 50+fname_over, "%s", pw->pw_name);
      } else
        sprintf(outbuf + 50+fname_over, "%d", current_lf->st_uid);
    }

    if ( tgz_flag ) {
      sprintf(outbuf + 58+fname_over, "%s", tgz_gid[current_lf->st_gid]);
    } else {
      if ((gr = getgrgid(current_lf->st_gid))) {           /* Group Id  */
        sprintf(outbuf + 58+fname_over, "%s", gr->gr_name);
      } else
        sprintf(outbuf + 58+fname_over, "%d", current_lf->st_gid);
    }

    t = localtime(&current_lf->st_mtime1);                /* Date Time */
    i = t->tm_year;
    if ( i > 99 )
      i = 100 - t->tm_year;
    sprintf(outbuf + 66+fname_over, "%2d:%2.2d %2d-%2.2d-%2.2d", t->tm_hour, t->tm_min,
            i, t->tm_mon + 1, t->tm_mday);

    sprintf(outbuf + 2, "%s", current_lf->st_name);      /* Name */

    for ( i = 0 ; i < 80+fname_over ; i++ )
        if ( !outbuf[i] )
            outbuf[i] = ' ';
    outbuf[80+fname_over] = 0;
}


/* ////////////////////////////////////////////////////////////////////////////
////            lf_draw_file                                               ////
////            ʬΥեɽ                               ////
//////////////////////////////////////////////////////////////////////////// */
void lf_draw_file(int i, int yy)
{
    int     xx, xpos, Ucmdlen;
    unsigned long ncolor;
    char    *ptr;
    struct  lf_stat  *current_lf;

    xx = 0;
    lf_out( spt[i] );
    current_lf = (struct lf_stat *)pfile[spt[i]];
    buffer[0] = current_lf->Mcmd;
    xpos = strlen(current_lf->st_name) + 3;
    if ( current_lf->Ucmd )
      Ucmdlen = strlen(current_lf->Ucmd);
    else
      Ucmdlen = 0;

    if ( current_lf->ersflag == '1' ) {
        outbuf[0] = buffer[0];
        strncpy(outbuf + xpos, current_lf->Ucmd, Ucmdlen);
	if ( color_flag )
	    XSetPlaneMask (pDisplay, gc, ndgcolor);
        XSetForeground(pDisplay, gc, ndgcolor);
        DrawText(xx, yy, outbuf, ALL);
    } else {
        XSetForeground(pDisplay, gc, nfgcolor);
        DrawText(xx, yy, outbuf, ALL);

	if ( color_flag )
	    XSetPlaneMask (pDisplay, gc, nbgcolor|ntgcolor|negcolor);
	XSetBackground(pDisplay, gc, nbgcolor);

                                            /* Mcommand */
        if ( buffer[0] != ' ' ) {
            if ( buffer[0] == '*' )
                ncolor = ntgcolor;
            else
                ncolor = negcolor;
            XSetForeground(pDisplay, gc, ncolor);
            DrawImageText(xx, yy, buffer, 1, 0);
        }
                                            /* Ucommand */
        if ( current_lf->Ucmd ) {
          if ( (ptr = search_notspace(current_lf->Ucmd))) {
            if ( *ptr == '*' )
              ncolor = ntgcolor;
            else
              ncolor = negcolor;
            XSetForeground(pDisplay, gc, ncolor);
            DrawImageText(xpos, yy, current_lf->Ucmd, ALL, 0);
          }
        }
    }
    if ( color_flag ) 
	XSetPlaneMask (pDisplay, gc, 0xffffffff);
}


/* ////////////////////////////////////////////////////////////////////////////
////            cursor_xx                                                  ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_xx(int flag)
{
    struct lf_stat *current_lf;
    int    i;

    if ( cmode == U_COMMAND ) {
        current_lf = (struct lf_stat *)pfile[spt[selfile]];
        if ( flag ) {
            if ( current_lf->Ucmd )
              i = strlen(current_lf->Ucmd);
            else
              i = 0;

            if ( pkey > i || Ucurrent_pkey > i )
                pkey = i;
            else
                pkey = Ucurrent_pkey;
        } else
            pkey = 0;
        curxx = strlen(current_lf->st_name) + pkey + 3;
    }
}


/* ////////////////////////////////////////////////////////////////////////////
////            lf_draw();                                                 ////
////            Τκ                                         ////
//////////////////////////////////////////////////////////////////////////// */
void lf_draw()
{
    int     xx, yy, i, j, keta ;
    char    buffer[32], buffer1[32];
    div_t   d;

    if ( !expose_flag )
        XClearWindow(pDisplay, window);
    xx = 0;
    yy = 0;

    XSetPlaneMask(pDisplay, gc, 0xffffffff);
    /* ----------------------------------------------  Host  --------- */
    XSetForeground(pDisplay, gc, nfgcolor);
    DrawText(xx, yy, "Host:", ALL);
    xx = 5;
    XSetForeground(pDisplay, gc, nhgcolor);
    DrawText(xx, yy, my_Hname, ALL);
    xx += strlen(my_Hname);

    /* ----------------------------------------------  Uid   --------- */
    XSetForeground(pDisplay, gc, nfgcolor);
    DrawText(++xx, yy, "Uid:", ALL);
    xx += 4;
    XSetForeground(pDisplay, gc, nhgcolor);
    DrawText(xx, yy, my_Uid, ALL);
    xx += strlen(my_Uid);

    /* ----------------------------------------------  Gid   --------- */
    XSetForeground(pDisplay, gc, nfgcolor);
    DrawText(++xx, yy, "Gid:", ALL);
    xx += 4;
    XSetForeground(pDisplay, gc, nhgcolor);
    DrawText(xx, yy, my_Gid, ALL);
    xx += strlen(my_Gid);

    /* ----------------------------------------------  ofxxxx  ------- */
    XSetForeground(pDisplay, gc, nfgcolor);
    sprintf(outbuf, "of%5d", nfile);
    DrawText(73+fname_over, yy, outbuf, ALL);

    /* ----------------------------------------------  Size  --------- */
    XSetForeground(pDisplay, gc, nfgcolor);
    DrawText(++xx, yy, "Size:", ALL);
    xx += 5;
    XSetForeground(pDisplay, gc, nhgcolor);

    sprintf(buffer, "%ld", size_total);
    keta = strlen(buffer);
    for ( i = j = 0 ; i < keta ; i++, j++ ) {
        buffer1[j] = buffer[i];
        d = div(keta - i, 3);
        if ( d.rem == 1 )
            buffer1[++j] = ',';
      }
    buffer1[j-1] = 0;
    sprintf(outbuf, "%s (%d Blk)", buffer1, size_total/512);
/*    sprintf(outbuf, "%d (%.2f MB)", size_total, (float)size_total/1024/1024);*/
    DrawText(xx, yy, outbuf, ALL);

    /* --------------------------------  Ԥ -----  Path  --------- */
    xx = 0;
    XSetForeground(pDisplay, gc, nfgcolor);
    memset(outbuf, '-', 256);
    strcpy(outbuf, "Path:");
    memset(outbuf + 5, ' ', strlen(opath) + 1);
    DrawText(xx, ++yy, outbuf, 80+fname_over);
    xx += 5;
    XSetForeground(pDisplay, gc, nhgcolor);
    DrawText(xx, yy, opath, ALL);

    /* ----------------------------------------------------------------- */
    dis_lines = QLines() - 3;
    dis_msg = QLines() - 1;

    dis_bottom = dis_top + dis_lines;
    if ( dis_bottom > nfile )
        dis_bottom = nfile;

    for ( yy = 2, i = dis_top  ; i < dis_bottom ; i++, yy++)
        lf_draw_file(i, yy);
    fkmsg_draw();

    /* ---------------------  Select File  ----------------------------- */
    if ((dis_cursor+3) > dis_msg ) { /* ɥ򾮤ν */
      dis_cursor = dis_msg - 3; 
      curyy = dis_msg - 1;
    }
    
    selfile = dis_top + dis_cursor;
    if ( selfile > nfile - 1 ) {
        selfile = nfile - 1;
        dis_cursor = dis_bottom - dis_top - 1;
        curyy = dis_cursor + 2;
    }
    select_file_box_no();

    /* ---------------------  Text Cursor  ----------------------------- */
   if ( !expose_flag ) {
        if ( cmode == U_COMMAND ) {
            cursor_xx(!execute_flag);
            if ( execute_flag )
                Ucurrent_pkey = 0;
        }
    }
    TextCursor(curxx, curyy);
}
