#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "define.h"
#include "lf.h"

/* ////////////////////////////////////////////////////////////////////////////
////            DrawText                                                   ////
////            ꤷ֤˥ƥȤɽ                           ////
//////////////////////////////////////////////////////////////////////////// */
void DrawText(int xx, int yy, char *str, int len)
{
    int xpos, ypos;

    xpos = nFontWidth * xx;
    ypos = nFontHeight * (yy + 1) -  descent;
    if ( len == ALL )
        len = strlen(str);
    if ( !jflag )
        XDrawString(pDisplay, window, gc, xpos, ypos, str, len);
    else
        XmbDrawString(pDisplay, window, fontset, gc, xpos, ypos, str, len);
}


/* ////////////////////////////////////////////////////////////////////////////
////            DrawImageText                                              ////
////            ꤷ֤˥᡼ƥȤɽ                   ////
//////////////////////////////////////////////////////////////////////////// */
void DrawImageText(int xx, int yy, char *str, int len, int offset)
{
    int     xpos, ypos;

    xpos = nFontWidth * xx;
    ypos = nFontHeight * (yy + 1) - descent + offset;
    if ( len == ALL )
        len = strlen(str);
    if ( !jflag )
        XDrawImageString(pDisplay, window, gc, xpos, ypos, str, len);
    else
        XmbDrawImageString(pDisplay, window, fontset, gc, xpos, ypos, str, len);
}


/* ////////////////////////////////////////////////////////////////////////////
////            select_file_box_no                                         ////
////            򤵤줿ե£ϣؤǰϤߡֹɽ               ////
//////////////////////////////////////////////////////////////////////////// */
void select_file_box_no()
{
    int     xx, yy, nWid, nHei;
    static int curyy_old = 2;
                                               /*  £ϣؾõ  */
    if ( color_flag ) {
	XSetPlaneMask(pDisplay, gc, ncgcolor);
	XSetForeground(pDisplay, gc, 0);
    } else
      XSetForeground(pDisplay, gc, nbgcolor);

    xx = 0;
    yy = nFontHeight * curyy_old;
    nWid = uWidth - 1;
    nHei = nFontHeight;
    XDrawRectangle(pDisplay, window, gc, xx, yy, nWid, nHei);

                                               /*  £ϣ  */
    XSetForeground(pDisplay, gc, ncgcolor);
    yy = nFontHeight * curyy;
    XDrawRectangle(pDisplay, window, gc, xx, yy, nWid, nHei);
    curyy_old = curyy;
                                               /*  ֹɽ  */
    if ( color_flag )
	XSetPlaneMask (pDisplay, gc, 0xffffffff);

    XSetForeground(pDisplay, gc, nfgcolor);
    XSetBackground(pDisplay, gc, px[0]);
    sprintf(outbuf, "%5d", selfile + 1);
    DrawImageText( 67+fname_over, 0, outbuf, ALL, 0);
}

/* ////////////////////////////////////////////////////////////////////////////
////            EraseBoxCursor                                             ////
////            £ϣءƥȥξõ                             ////
//////////////////////////////////////////////////////////////////////////// */
void EraseBoxCursor(int xx, int yy)
{
  int    xx1, yy1, nWid, nHei;

  /*  £ϣؾõ  */
  XSetForeground(pDisplay, gc, nbgcolor);
  xx1 = 0;
  yy1 = nFontHeight * curyy;
  nWid = uWidth - 1;
  nHei = nFontHeight;
  XDrawRectangle(pDisplay, window, gc, xx1, yy1, nWid, nHei);
  
  /*  õ  */
  xx1 = nFontWidth * xx;
  nWid = nFontWidth;
  yy1 = nFontHeight * yy + 1;
  nHei = nFontHeight - 1;
  XDrawRectangle(pDisplay, window, gc, xx1, yy1-1, nWid, nHei+1);
}


/* ////////////////////////////////////////////////////////////////////////////
////            TextCursor                                                 ////
////            ƥȥκ                                     ////
//////////////////////////////////////////////////////////////////////////// */
void TextCursor(int xx, int yy)
{
    int    xx1, yy1, nWid, nHei;
    static int xx0, yy0 = 2;
    static char dash[] = { 1, 1};
    static unsigned int linew = 1;
                                               /*  õ  */
    if ( color_flag ) {
        XSetPlaneMask(pDisplay, gc, ncgcolor);
        XSetForeground(pDisplay, gc, 0);
    } else
        XSetForeground(pDisplay, gc, nbgcolor);

    xx1 = nFontWidth * xx0;
    yy1 = nFontHeight * yy0 + 1;
    nWid = nFontWidth;
    nHei = nFontHeight - 1;

    if ( color_flag ) 
	XFillRectangle(pDisplay, window, gc, xx1, yy1, nWid, nHei);
    else
	XDrawRectangle(pDisplay, window, gc, xx1, yy1-1, nWid, nHei+1);

                                               /*  £ϣ  */
    XSetForeground(pDisplay, gc, ncgcolor);
    xx1 = 0;
    yy1 = nFontHeight * curyy;
    nWid = uWidth - 1;
    nHei = nFontHeight;
    XDrawRectangle(pDisplay, window, gc, xx1, yy1, nWid, nHei);

                                               /*    */
    xx1 = nFontWidth * xx;
    nWid = nFontWidth;
    if ( color_flag ) {                     /* ץ饤١ȥ顼 */
	if ( !insert_flag ) {               /* Overwrite */
	    yy1 = nFontHeight * yy + 1;
	    nHei = nFontHeight - 1;
	} else {                            /* Insert */
	    yy1 = nFontHeight * yy + nFontHeight / 2;
	    nHei = nFontHeight * (yy + 1) - yy1;
	}
	XFillRectangle(pDisplay, window, gc, xx1, yy1, nWid, nHei);
	XSetPlaneMask(pDisplay, gc, 0xffffffff);
    } else {                                /* ɸ५顼 */
	yy1 = nFontHeight * yy + 1;
	nHei = nFontHeight - 1;
	if ( !insert_flag ) {               /* Overwrite */
	    XSetLineAttributes(pDisplay, gc, linew, LineSolid, CapButt, JoinMiter);
	} else {                            /* Insert */
	    XSetForeground(pDisplay, gc, nbgcolor);
	    XDrawRectangle(pDisplay, window, gc, xx1, yy1-1, nWid, nHei+1);
	    XSetForeground(pDisplay, gc, ncgcolor);
	    XSetDashes(pDisplay, gc, 0, dash, 2);
	    XSetLineAttributes(pDisplay, gc, linew, LineOnOffDash, CapButt, JoinMiter);
	}
	XDrawRectangle(pDisplay, window, gc, xx1, yy1-1, nWid, nHei+1);
	XSetLineAttributes(pDisplay, gc, linew, LineSolid, CapButt, JoinMiter);
    }

    xx0 = xx;
    yy0 = yy;
}


/* ////////////////////////////////////////////////////////////////////////////
////          ClearTextArea                                                ////
////          ꤷ֤ؼΥƥȤä                 ////
//////////////////////////////////////////////////////////////////////////// */
void ClearTextArea(int xx, int yy, int keta)
{
    int     xx1, yy1, nWid, nHei;
    xx1 = nFontWidth * xx;
    yy1 = nFontHeight * yy + 1;
    nWid = nFontWidth * keta;
    nHei = nFontHeight;
    XClearArea(pDisplay, window, xx1, yy1, nWid, nHei, False);
}


/* ////////////////////////////////////////////////////////////////////////////
////          ClearPlaneArea                                               ////
////          եޥɥƥȤξõ                                     ////
//////////////////////////////////////////////////////////////////////////// */
void ClearPlaneArea(int xx, int yy, int keta)
{
    int     xx1, yy1, nWid, nHei;
    xx1 = nFontWidth * xx;
/*    yy1 = nFontHeight * yy;*/
    yy1 = nFontHeight * yy + 1;
    nWid = nFontWidth * keta;
/*    nHei = nFontHeight;*/
    nHei = nFontHeight - 1;

    if ( color_flag ) {
	XSetPlaneMask (pDisplay, gc, nbgcolor|ntgcolor|negcolor);
	XSetForeground(pDisplay, gc, 0);
	XFillRectangle(pDisplay, window, gc, xx1, yy1, nWid, nHei);
	XSetPlaneMask (pDisplay, gc, 0xffffffff);
    } else {
	XSetForeground(pDisplay, gc, nbgcolor);
	XFillRectangle(pDisplay, window, gc, xx1, yy1, nWid, nHei);
    }
}


/* ////////////////////////////////////////////////////////////////////////////
////          CopyPlaneArea                                                ////
////          եޥɥƥȤΥԡ                                   ////
//////////////////////////////////////////////////////////////////////////// */
void CopyPlaneArea(src_x, src_y, dest_x, dest_y, keta)
    int src_x, src_y, dest_x, dest_y, keta;
{
    int xx1, yy1, xx2, yy2, nWid, nHei;
    xx1 = nFontWidth * src_x;
    yy1 = nFontHeight * src_y;
    xx2 = nFontWidth * dest_x;
    yy2 = nFontHeight * dest_y;
    nWid = nFontWidth * keta;
    nHei = nFontHeight;

    if ( color_flag ) {
	XSetPlaneMask (pDisplay, gc, nbgcolor|ntgcolor|negcolor);
	XCopyArea(pDisplay, window, window, gc, xx1, yy1, nWid, nHei, xx2, yy2);
	XSetPlaneMask (pDisplay, gc, 0xffffffff);
    } else
	XCopyArea(pDisplay, window, window, gc, xx1, yy1, nWid, nHei, xx2, yy2);
}
