#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include "define.h"
#include "lf.h"

/* ////////////////////////////////////////////////////////////////////////////
////            handleKeyboard                                             ////
//////////////////////////////////////////////////////////////////////////// */
void handleKeyboard()
{
    int     len;
    char    *ptr;
    struct  lf_stat  *current_lf;

    current_lf = (struct lf_stat *)pfile[spt[selfile]];
    XLookupString(&report.xkey, buffer, MAXBUFF, &myKeysym, &myStatus);
    /*    printf("myKeysym : %x\n", myKeysym);*/

    /* --------  emacs key_bindings  -------- */
    if ( alt_flag ) {
        switch (myKeysym) {
        case 'v':
            myKeysym = XK_Prior;
            break;
        }
    }

    if ( ctrl_flag ) {
        switch (myKeysym) {
        case 'a':
            if ( cmode == U_COMMAND ) {
                Ucurrent_pkey = pkey = 0;
                curxx = strlen(current_lf->st_name) + 3;
                TextCursor(curxx, curyy);
            }
            return;
        case 'e':
            if ( cmode == U_COMMAND ) {
                pkey = strlen(current_lf->Ucmd);
                Ucurrent_pkey = 999;
                curxx = pkey + strlen(current_lf->st_name) + 3;
                TextCursor(curxx, curyy);
            }
            return;
        case 'v':
            myKeysym = XK_Next;
            break;
        case 'd':
            myKeysym = XK_Delete;
            break;
        case 'f':
            if ( cmode == U_COMMAND ) { /*  Cursor Right  */
                if ( pkey < strlen(current_lf->Ucmd) ) {
                    TextCursor(++curxx, curyy);
                    Ucurrent_pkey = ++pkey;
                }
            }
            return;
        case 'b':
            if ( cmode == U_COMMAND ) { /*  Cursor Left  */
                if ( (strlen(current_lf->st_name) + 3) < curxx ) {
                    TextCursor(--curxx, curyy);
                    Ucurrent_pkey = --pkey;
                }
            }
            return;
        case 'n':
            myKeysym = XK_Down;
            break;
        case 'p':
            myKeysym = XK_Up;
            break;
        case 'k':
            myKeysym = XK_End;
            break;
        case 'g':     /*  ¹  97.7.17 */
	    execute_flag = 1;
	    if ( cmode == M_COMMAND )
	      MExecute();
	    else
	      UExecute();
	    execute_flag = 0;
            return;
        }
    }

    switch (myKeysym) {
    case XK_Shift_L:            /* Shift */
    case XK_Shift_R:
        shift_flag = 1;
        fkmsg_draw();
        break;

    case XK_Control_L:          /* Control */
    case XK_Control_R:
        ctrl_flag = 1;
        fkmsg_draw();
        break;

    case XK_Alt_L:              /* Alt */
    case XK_Alt_R:
        alt_flag = 1;
        fkmsg_draw();
        break;

    case XK_Insert:             /*  Ins  */
        insert_flag = ~insert_flag;
        TextCursor(curxx, curyy);
        break;

    case XK_Delete:             /*  Del  */
        deletekey();
        break;

    case XK_Return:             /*  Return  */
    case XK_KP_Enter:
        if ( shift_flag ) {
            if ( cmode == U_COMMAND ) {
                return_flag = 1;
                UExecute();
                return_flag = 0;
            }
        } else {
	  if ( action_flag ) 
            cursor_down(0);
	  else {
            execute_flag = 1;
            if ( cmode == M_COMMAND )
                MExecute();
            else
                UExecute();
            execute_flag = 0;
	  }
        }
        break;

    case XK_Execute:            /*  Action  */
	  if ( action_flag ) {
	    execute_flag = 1;
	    if ( cmode == M_COMMAND )
	      MExecute();
	    else
	      UExecute();
	    execute_flag = 0;
	  }
        break;

    case XK_Escape:             /*  Escape  */
        Quit();
        break;

    case XK_BackSpace:          /*  BackSpace  */
        backspacekey();
        break;

    case XK_Tab:                        /*  Tab  */
        cmode = ~cmode;
        if ( cmode == U_COMMAND ) {
            Ucurrent_pkey = pkey = 0;
            curxx = strlen(current_lf->st_name) + 3;
        } else
            curxx = 0;
        TextCursor(curxx, curyy);
        break;

    case XK_Prior:              /*  Page Up  */
        if ( !dis_top )
            cursor_top();
        else {
            dis_top -= dis_lines;
            if ( dis_top < 0 )
                dis_top = 0;
            lf_draw();
        }
        break;

    case XK_Next:                       /*  Page Down  */
        if ( (dis_top + dis_lines) < nfile ) {
            dis_top += dis_lines;
            lf_draw();
        } else
            cursor_bottom();
        break;

    case XK_Home:                       /*  Top & Bottom  */
        if ( !home_flag ) {
            if ( dis_top ) {
                dis_top = 0;
                lf_draw();
            }
            cursor_top();
        } else {
            if ( (nfile - dis_lines) != dis_top ) {
                if ( nfile > dis_lines ) {
                    dis_top = nfile - dis_lines;
                    lf_draw();
                }
            }
            cursor_bottom();
        }
        home_flag = ~home_flag;
        break;

    case XK_End:                        /*  Erase Eof  */
        if ( cmode == U_COMMAND ) {
	  if ( current_lf->Ucmd ) {
            ptr = current_lf->Ucmd + pkey;
            if ( len = strlen(ptr)) {
	      Ucmd_move(ptr, ptr+len, Ucmd_unuse - ptr - len, -len);
	      memset(Ucmd_unuse, 0, len-1);
	      ClearPlaneArea(curxx, curyy, len + 0);
	      TextCursor(curxx, curyy);
#ifdef DEBUG
	      Ucmd_area_debug();
#endif
	    }
	  }
	}
        break;

    case XK_F1:                 /*  F1  */
        function_execute(0);
        break;

    case XK_F2:                 /*  F2  */
        function_execute(1);
        break;

    case XK_F3:                 /*  F3  */
        function_execute(2);
        break;

    case XK_F4:                 /*  F4  */
        function_execute(3);
        break;

    case XK_F5:                 /*  F5  */
        function_execute(4);
        break;

    case XK_F6:                 /*  F6  */
        function_execute(5);
        break;

    case XK_F7:                 /*  F7  */
        function_execute(6);
        break;

    case XK_F8:                 /*  F8  */
        function_execute(7);
        break;

    case XK_F9:                 /*  F9  */
        function_execute(8);
        break;

    case XK_F10:                        /*  F10  */
        function_execute(9);
        break;

    case XK_F11:                        /*  F11  */
        function_execute(10);
        break;

    case XK_F12:                        /*  F12  */
        function_execute(11);
        break;

    case XK_Up:                 /*  Cursor Up  */
        if ( !shift_flag ) {
            cursor_up();
        } else                  /*  Shift+Cursor Up  */
            cursor_top();
        break;

    case XK_Down:                       /*  Cursor Down  */
        if ( !shift_flag ) {
            cursor_down(1);
        } else                  /*  Shift+Cursor Down  */
            cursor_bottom();
        break;

    case XK_Right:              /*  Right  */
        if ( ctrl_flag ) {              /*  Scroll down  */
            if ( (dis_top + dis_lines) < nfile ) {
                dis_top += dis_cursor;
                lf_draw();
            }
            break;
        }

        if ( shift_flag ) {             /*  üذư  */
            if ( cmode == U_COMMAND ) {
                if ( current_lf->Ucmd ) {
                    pkey = strlen(current_lf->Ucmd);
                    Ucurrent_pkey = 999;
                    curxx = pkey + strlen(current_lf->st_name) + 3;
                    TextCursor(curxx, curyy);
                }
            }
            break;
        }

        if ( cmode == U_COMMAND ) {     /*  Cursor Right  */
            if ( current_lf->Ucmd ) {
                if ( pkey < strlen(current_lf->Ucmd) ) {
                    TextCursor(++curxx, curyy);
                    Ucurrent_pkey = ++pkey;
                }
            }
        }
        break;

    case XK_Left:                       /*  Left  */
        if ( ctrl_flag ) {              /*  Scroll Up  */
            if ( dis_top ) {
                dis_top -= dis_cursor;
                if ( dis_top < 0 )
                    dis_top = 0;
                lf_draw();
            }
            break;
        }

        if ( shift_flag ) {             /*  üذư  */
            if ( cmode == U_COMMAND ) {
                Ucurrent_pkey = pkey = 0;
                curxx = + strlen(current_lf->st_name) + 3;
                TextCursor(curxx, curyy);
            }
            break;
        }

        if ( cmode == U_COMMAND ) {     /*  Cursor Left  */
            if ( (strlen(current_lf->st_name) + 3) < curxx ) {
                TextCursor(--curxx, curyy);
                Ucurrent_pkey = --pkey;
            }
        }
        break;

    default:
        if ( isprint(buffer[0]) ) {
            if ( cmode == M_COMMAND ) {
                if ( current_lf->ersflag == '0' ) {
                    current_lf->Mcmd = buffer[0];
		    if ( color_flag )
			XSetPlaneMask (pDisplay, gc, nbgcolor|ntgcolor|negcolor);
                    XSetForeground(pDisplay, gc, ntgcolor);
                    XSetBackground(pDisplay, gc, nbgcolor);
                    DrawImageText( curxx, curyy, buffer, 1, 0);
		    if ( color_flag )
			XSetPlaneMask (pDisplay, gc, 0xffffffff);
		    else
			TextCursor(curxx, curyy);
                }
                if ( insert_flag )
                    cursor_down(0);
            } else
                insertkey();
        }
    }
}
