/* ////////////////////////////////////////////////////////////////////////////
////            եٱġ   Version 2.4                       ////
////                                                                       ////
////                   for X Window System                                 ////
////                                                   92/ 6/20    ////
////                                                       96/ 5/26    ////
//////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>  /*  MAXPATHLEN  */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include "define.h"

#ifdef XPM
#include <X11/xpm.h>
#include "lf.xpm"
#else
#include "lf.xbm"
#endif

XFontStruct     *pFontInfo = NULL;
Display         *pDisplay;
GC              gc;
XEvent          report;
Window          window;
KeySym          myKeysym;
XComposeStatus  myStatus;
XFontSet        fontset;
XFontSetExtents *fontset_ext;

struct lf_stat {
    char    *st_name;           /* File Name                      */
    short   st_nlink;           /* Number of links                */
    mode_t  st_mode;            /* File mode; see #define's below */
    uid_t   st_uid;             /* User ID of the file's owner    */
    gid_t   st_gid;             /* Group ID of the file's group   */
    off_t   st_size;            /* File size in bytes             */
    time_t  st_mtime1;          /* Time of last access            */
    char    Mcmd;               /* Mcommand ϰ */
    char    *Ucmd;              /* Ucommand ϰ */
    char    ersflag;            /* File Erase Flag */
    struct  lf_stat  *next;
}  *first_lf;

char    **pfile;                /* lf_stat *next pointer */
int     nfile = 0;              /* File ο */
int     *spt;                   /* struct lf_stat  index */
char    my_Hname[64];           /* Host Name */
char    my_Uid[10];             /* Owner Id  */
char    my_Gid[10];             /* Group Id  */
char    my_PWD[MAXPATHLEN];     /* PWD       */
char    ipath[MAXPATH];         /* in  Path  */
char    opath[MAXPATH];         /* out Path  */
char    outbuf[256];
char    sFontName[MAXBUFF];     /* Font Name */
char    jsFontName[MAXBUFF];    /* ܸ Font Name */
char    windowenv1[MAXBUFF];    /* New Window  ! */
char    windowenv2[MAXBUFF];    /* New Window  !! */
char    buffer[MAXBUFF];
char    asm_command[256];       /* Ÿ줿 Ucommand */
char    locale[20];             /* LC_CTYPE */

unsigned int    uWidth;         /* Window Size */
unsigned int    uHeight;        /* Window Size */

unsigned long   nbgcolor ;   /* Back Ground Color */
unsigned long   nfgcolor ;   /* Fore Ground Color */
unsigned long   ncgcolor ;   /* Select file Color */
unsigned long   ntgcolor ;   /* Text        Color */
unsigned long   negcolor ;   /* Execute Err Color */
unsigned long   ndgcolor ;   /* File Erase  Color */
unsigned long   nhgcolor ;   /* Host ...    Color */
unsigned long   nmgcolor1;   /* Function msg1 Color */
unsigned long   nmgcolor2;   /* Function msg2 Color */
unsigned long   nmgcolor3;   /* Function msg3 Color */
unsigned long   nmgcolor4;   /* Function msg4 Color */
unsigned long   nrgcolor;    /* Running msg Color */

unsigned long   px[2];       /* base pixel */
unsigned long   pl[4];       /* plane mask */

char    bgcolor[MAXCOLOR];    /* Back Ground Color */
char    fgcolor[MAXCOLOR];    /* Fore Ground Color */
char    cgcolor[MAXCOLOR];    /* Select file Color */
char    tgcolor[MAXCOLOR];    /* Text        Color */
char    egcolor[MAXCOLOR];    /* Execute Err Color */
char    dgcolor[MAXCOLOR];    /* File Erase  Color */
char    hgcolor[MAXCOLOR];    /* Host ...    Color */
char    mgcolor1[MAXCOLOR];   /* Function msg1 Color */
char    mgcolor2[MAXCOLOR];   /* Function msg2 Color */
char    mgcolor3[MAXCOLOR];   /* Function msg3 Color */
char    mgcolor4[MAXCOLOR];   /* Function msg4 Color */

int     dis_top = 0;     /* Display Top File No.      */
int     dis_bottom;      /* Display Bottom File No.   */
int     dis_msg;         /* Display Message Position  */
int     dis_lines;       /* Display File Max          */
int     dis_cursor = 0;  /* Display Select File Posision   */

int     sortflag_name = 0;        /* Sort Flag */
int     sortflag_mode = (int)-1;  /* Sort Flag */
int     sortflag_size = 0;        /* Sort Flag */
int     sortflag_owner = 0;       /* Sort Flag */
int     sortflag_date = (int)-1;  /* Sort Flag */
int     sortflag_dott = 0;        /* Sort Flag */
int     sortflag_link = 0;        /* Sort Flag */
int     fontflag = 0;             /* -fn  */
int     jflag = 0;                /* ܸ ڤ괹 */
int     cmode = M_COMMAND;        /* command ڤ괹 */
int     shift_flag = 0;           /* Shift_key flag */
int     ctrl_flag = 0;            /* Ctrl_key flag */
int     alt_flag = 0;             /* Alt_key flag */
int     insert_flag = 0;          /* Insert key flag */
int     home_flag = (int)-1;      /* Home   key flag */
int     return_flag = 0;          /* Return Key flag */
int     expose_flag = 0;          /* Expose ˥֤Ѥʤ */
int     date_flag = 0;            /* File Date flag */
int     execute_flag = 0;         /* Execute flag */
char    in_date[14];              /* yymmdd-yymmdd */
int     refresh_flag = 0;         /* refresh flag */
int     seiki_flag = 0;           /* seikika flag */
int     tgz_flag = 0;             /* tgz flag */
int     color_flag = 1;           /* 0:ɸ   1:ץ饤١ */
int     action_flag = 0;          /* 0:Enter key  1:Action key */
int     stdin_flag = 0;           /* 0:           1:stdin */
int     lzh_type = 0;             /* 0: rwxrwxrwx  1:¾  */
char    lzh_permission_type[10];  /* [xxxxxxx] */
char    *Ucmd_area;
char    *Ucmd_unuse;              /* Ucmd_area ̤ΰΥݥ󥿡 */

int     Ucurrent_pkey = 0;  /* Ucmd current pkey */
int     curxx = 0;        /* Cursor Position */
int     curyy = 2;        /* Cursor Position */
int     selfile = 0;      /* Select File No */
int     pkey = 0;
int     nFontHeight;      /* ʸ⤵ */
int     nFontWidth;       /* ʸ   */
short int       ascent, descent;  /* Font ascent, descent */
unsigned long   size_total;       /* File Size  */
int     fname_over = 0;      /*  ե̾ 25ʸۤʬʸ  */


char *tgz_uid[100];
char *tgz_gid[100];
int ntgz_uid = 0, ntgz_gid = 0;


char    *fkcmd[13];         /* Function Key Command */
char    *fkmsg[] = {
        "Exec", "More", "View", " Vi ",
        "S/na", "S/mo", "S/si", "S/ow",
        "S/da", "S/.*", "S/li", "Refr"
        };

char    *fkcmd_default[] = {
        "./\\ &",
        "!more \\ &",
        "!view \\ &",
        "!vi   \\ &",
        "@Sort_name",
        "@Sort_mode",
        "@Sort_size",
        "@Sort_owner",
        "@Sort_date",
        "@Sort_dott",
        "@Sort_link",
        "@Refresh",
        NULL     };

char    *skcmd[13];         /* Shift Key Command */
char    *skmsg[] = {
        "    ", "    ", "    ", "    ",
        "    ", "    ", "    ", "    ",
        "    ", "    ", "    ", "    "
        };

char    *ckcmd[13];         /* Ctrl Key Command */
char    *ckmsg[] = {
        "    ", "    ", "    ", "    ",
        "    ", "    ", "    ", "    ",
        "    ", "    ", "    ", "    "
        };

char    *akcmd[13];        /* Alt Key Command */
char    *akmsg[] = {
        "    ", "    ", "    ", "    ",
        "    ", "    ", "    ", "    ",
        "    ", "    ", "    ", "    "
        };

char    *pMcmd;
char    *Mcmd_default[] = {
        "f=lf \\ &",
        "b=cp \\ \\.bak",
        "c=cc -o \\n \\",
        "h=head \\",
        "t=tail \\",
        "m=!mule \\ &",
        "v=!vi \\ &",
        "l=lpr \\",
        "1=cc -lX11 -o \\n \\",
        NULL     };

char    *Mcmd[MAXMCOMM];

int main(argc, argv, envp)
    int     argc;
    char    **argv;
    char    **envp;
{
    char    **pt = argv;
    Pixmap  pixmap;
    Window  winRoot;
    XSizeHints      hints;
    unsigned long   wEventMask;
    unsigned int    uModlength;
    unsigned int    uNewHeight;
    unsigned int    uNewWidth;
    int     nScreen, i;
#ifdef XPM
    XpmAttributes xpm_attr;
#endif

    /* ---------------------  default set  ----------------------------- */
    strcpy(sFontName, FONT);
    strcpy(jsFontName, JPFONT);
    strcpy(fgcolor, FGCOLOR);
    strcpy(bgcolor, BGCOLOR);
    strcpy(cgcolor, CGCOLOR);
    strcpy(tgcolor, TGCOLOR);
    strcpy(egcolor, EGCOLOR);
    strcpy(dgcolor, DGCOLOR);
    strcpy(hgcolor, HGCOLOR);
    strcpy(mgcolor1, MGCOLOR1);
    strcpy(mgcolor2, MGCOLOR2);
    strcpy(mgcolor3, MGCOLOR3);
    strcpy(mgcolor4, MGCOLOR4);
    strcpy(windowenv1, WINDOWENV1);
    strcpy(windowenv2, WINDOWENV2);
    strcpy(locale, LOCALE);
    strcpy(ipath, ".");

    for ( i = 0 ; i < argc ; i++ ) {
      if ( !strcmp(argv[i], "-tgz"))
	tgz_flag = 1;
      else if ( !strcmp(argv[i], "-lzh"))
	tgz_flag = 2;
      else if ( !strcmp(argv[i], "-zip"))
	tgz_flag = 3;
    }

    /* ---------------------  resource set  ---------------------------- */
    lf_resource();

    /* ---------------------  command line set  ------------------------ */
    while ( *++pt ) {
        if ( !strcmp(*pt, "-fn")) {
            strcpy(sFontName, *++pt);
	    fontflag = 1;
        } else if ( !strcmp(*pt, "-fg"))
            strcpy(fgcolor, *++pt);
        else if ( !strcmp(*pt, "-bg"))
            strcpy(bgcolor, *++pt);
        else if ( !strcmp(*pt, "-cg"))
            strcpy(cgcolor, *++pt);
        else if ( !strcmp(*pt, "-eg"))
            strcpy(egcolor, *++pt);
        else if ( !strcmp(*pt, "-dg"))
            strcpy(dgcolor, *++pt);
        else if ( !strcmp(*pt, "-hg"))
            strcpy(hgcolor, *++pt);
        else if ( !strcmp(*pt, "-tg"))
            strcpy(tgcolor, *++pt);
        else if ( !strcmp(*pt, "-J"))
            jflag = 1;
        else if ( !strcmp(*pt, "-s"))
            seiki_flag = 1;
        else if ( !strcmp(*pt, "-tgz"))
            continue;
        else if ( !strcmp(*pt, "-lzh"))
            continue;
        else if ( !strcmp(*pt, "-zip"))
            continue;
        else if ( !strcmp(*pt, "-nocell")) {
	    color_flag = 0;
            continue;
        } else if ( !strcmp(*pt, "-date")) {
            strcpy(in_date, *++pt);
            date_flag = 1;
        } else if ( !strcmp(*pt, "-i")) {
            stdin_flag = 1;
        } else if ( !strcmp(*pt, "-v")) {
            printf("%s\n", VERSION);
            printf("%s\n", NIFTYID);
            exit (0);
        } else if ( !strcmp(*pt, "-h")) {
            printf(
               "Usage: lf [path]\n" \
               "  options:\n" \
               "    [-fn Font]\n" \
               "    [-J (ܸ⡼)]\n" \
               "    [-bg Background Color]\n" \
               "    [-fg Foreground Color]\n" \
               "    [-cg Cursor Color]\n" \
               "    [-tg Text Color]\n" \
               "    [-eg Execute Error color]\n" \
               "    [-dg File Erase Color]\n" \
               "    [-s ɽ]\n" \
               "    [-tgz (tgz + (gz,Z) ե򳫤)]\n" \
               "    [-lzh (lha ե򳫤)]\n" \
               "    [-zip (zip ե򳫤)]\n" \
               "    [-date -yymmdd | yymmdd | yymmdd- | yymmdd-yymmdd]\n" \
               "    [-nocell (ץ饤١ȥ顼Ѥʤ)]\n" \
               "    [-i  (stdin)]\n" \
               "    [-v  (Version)]\n");
            exit (0);
        } else {
            strcpy(ipath, *pt);
	    if ( seiki_flag ) /*  ΰ lf_set()Ϥ  */
	      break;
        }
    }

    /* ---------------------  lf_set  ---------------------------------- */
    if ( tgz_flag ) 
      lf_set_tgz();
    else
      lf_set(pt);

    /* ---------------------  Connect to X Server  --------------------- */
    if ( !(pDisplay = XOpenDisplay(NULL))) {
        fprintf(stderr, "lf can't open %s\n", XDisplayName(NULL));
        exit (4);
    }

    /* ---------------------  Setup Graphics Context  ------------------ */
    nScreen = DefaultScreen (pDisplay);
    winRoot = XDefaultRootWindow(pDisplay);
    gc = DefaultGC(pDisplay, nScreen);

    /* ---------------------  Color Set  ------------------------------- */
    color_define();

    /* ---------------------  Font set  -------------------------------- */
    SetNewFont();

    /* ---------------------  XCreateSimpleWindow  --------------------- */
    uWidth = nFontWidth * (KETA+fname_over) + 2;
    i = GYO;
    if ( i > nfile + 3 )
        i = nfile + 3;
    uHeight = nFontHeight * i + 2;
    window = XCreateSimpleWindow(pDisplay, winRoot, 0, 0, uWidth, uHeight,
                                 0, 0, px[0]);

    /*      ӥåȥޥåץǡݥμ       */
#ifdef XPM
    xpm_attr.colormap = DefaultColormap(pDisplay, 0);
    xpm_attr.valuemask = XpmSize | XpmReturnPixels | XpmColormap;
    XpmCreatePixmapFromData(pDisplay, window, lf_xpm, &pixmap,
                            NULL, &xpm_attr);
#else
    pixmap = XCreateBitmapFromData(pDisplay, window, lf_bits, lf_width,
                                   lf_height);
#endif

    strcat(strcpy(buffer, "lf "), opath);
    hints.flags = 0;
    XSetStandardProperties(pDisplay, window, buffer, argv[0], pixmap,
                           argv, argc, &hints);

    /* ---------------------  Change cursor to personal preference  ---- */
    Change_Cursor(XC_gumby);

    /* ---------------------  Map window  ------------------------------ */
    XMapWindow(pDisplay, window);

    /* ---------------------  Select input events to moinitor  --------- */
    wEventMask = ButtonPressMask | StructureNotifyMask | KeyPressMask |
                 ExposureMask | KeymapStateMask | KeyReleaseMask;
    XSelectInput(pDisplay, window, wEventMask);

    /* ---------------------  Enter infinite event loop  --------------- */
    while (True) {
        XNextEvent (pDisplay, &report);

        switch (report.type) {
        case ButtonPress:
            switch ( report.xbutton.button ) {
            case Button1:
                break;

            case Button2:
                strcpy(buffer, windowenv1);
                strcat(buffer, " &");
                system(buffer);
                break;

            case Button3:
                Quit();
            }
            break;

        case KeyPress:
            handleKeyboard();
            break;

        case KeyRelease:
            if ( shift_flag ) {
                XLookupString(&report.xkey, buffer, MAXBUFF, &myKeysym, &myStatus);
                if ( myKeysym == XK_Shift_L || myKeysym == XK_Shift_R ) {
                    shift_flag = 0;
                    fkmsg_draw();
                }
            }

            if ( ctrl_flag ) {
                XLookupString(&report.xkey, buffer, MAXBUFF, &myKeysym, &myStatus);
                if ( myKeysym == XK_Control_L || myKeysym == XK_Control_R ) {
                    ctrl_flag = 0;
                    fkmsg_draw();
                }
            }

            if ( alt_flag ) {
                XLookupString(&report.xkey, buffer, MAXBUFF, &myKeysym, &myStatus);
                if ( myKeysym == XK_Alt_L || myKeysym == XK_Alt_R ) {
                    alt_flag = 0;
                    fkmsg_draw();
                }
            }
            break;

        case ConfigureNotify:
            uNewHeight = report.xconfigure.height;
            uNewWidth  = report.xconfigure.width;

            if ((uNewHeight != uHeight) || (uNewWidth != uWidth) ) {
                uWidth  = uNewWidth ;
                uHeight = uNewHeight / nFontHeight * nFontHeight + 2;

		i = uWidth / nFontWidth;
		if ( i < 80 ) 
		  fname_over = 0;
		else 
		  fname_over = i - 80;
/*		XResizeWindow(pDisplay, window, uWidth, uHeight);*/
                lf_draw(); /*  expose   */
            }
            break;

        case Expose:
            while ( XCheckTypedEvent(pDisplay, Expose, &report));
            if ( !report.xexpose.count ) {
                expose_flag = 1;
                shift_flag = 0;
                ctrl_flag = 0;
                alt_flag = 0;
                lf_draw();
                expose_flag = 0;
            }
            break;

        default:
            break;
        }
    }
}
