#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <pwd.h>
#include <grp.h>
#include <time.h>
#include <dirent.h>
#include "define.h"
#define NOT_X
#include "lf.h"
#undef NOT_X

/* ////////////////////////////////////////////////////////////////////////////
////            lf_set_date                                                ////
////            եդΥåԤʤ                         ////
//////////////////////////////////////////////////////////////////////////// */
int lf_set_date(wdate)
     time_t *wdate;
{
    static int len_in_date = 0;
    int ret;
    struct tm *t;

    if ( !len_in_date )
        len_in_date = strlen(in_date);

    t = localtime(wdate);
    sprintf(outbuf, "%2.2d%2.2d%2.2d", t->tm_year, t->tm_mon + 1, t->tm_mday);

    if ( len_in_date == 6 ) {
        memmove(in_date+7, in_date, 6);
    } else if ( len_in_date == 7 ) {
        if ( in_date[0] == '-' ) {
            memmove(in_date+7, in_date+1, 6);
            memmove(in_date, "000000", 6);
        } else if ( in_date[6] == '-' )
            memmove(in_date+7, "999999", 6);
    }

    if ( memcmp(outbuf, in_date, 6) >= 0 &&
         memcmp(outbuf, in_date+7, 6) <= 0 )
        ret = 0;
    else
        ret = 1;

    return ret;
}


/* ////////////////////////////////////////////////////////////////////////////
////            lf_set_stat                                                ////
////            եξɤ߹                                   ////
//////////////////////////////////////////////////////////////////////////// */
void lf_set_stat(fname)
     char *fname;
{
  struct stat buff;
  struct lf_stat *new_lf;
  static struct lf_stat *old_lf;
  int i;
  div_t d;

  /*------------------------------  stat  ---------------------*/
  if ( stat(fname, &buff) == -1 ) {
    fprintf(stderr, "%s not found\n", fname);
    return;
  }

  /*------------------------------  date check  ---------------*/
  if ( date_flag ) {
    if ( lf_set_date(&buff.st_mtime))
      return;
  }

  /*------------------------------  calloc  (lf_stat)  --------*/
  if ( !(new_lf = calloc(1, sizeof(struct lf_stat)))) {
    fprintf(stderr, "<<<  Out of Memory (stat) >>>\n");
    exit (4);
  }

  /*------------------------------  calloc  (fname)  ----------*/
  if ( !(new_lf->st_name = calloc(1, strlen(fname)+1))) {
    fprintf(stderr, "<<<  Out of Memory  (fname) >>>\n");
    exit (4);
  }

  /*  fname_over set  */
  i = strlen(fname) - 25;
  if ( i > 0 ) {
    if ( fname_over < i )
      fname_over = i;
  }
  strcpy(new_lf->st_name, fname);
  new_lf->st_nlink = buff.st_nlink;
  new_lf->st_mode  = buff.st_mode;
  new_lf->st_uid   = buff.st_uid;
  new_lf->st_gid   = buff.st_gid;
  new_lf->st_size  = buff.st_size;
  new_lf->st_mtime1 = buff.st_mtime;
  new_lf->Mcmd = ' ';
  new_lf->Ucmd = NULL;
  new_lf->ersflag = '0';
  nfile++;

  if ( !(buff.st_mode & S_IFDIR)) {
    d = div(buff.st_size, 512);
    if ( d.rem )
      d.quot++;
    size_total += d.quot * 512;
  }
/*
    size_total += buff.st_size;
*/
  if ( first_lf == NULL ) {
    first_lf = new_lf;
    old_lf = new_lf;
  } else {
    old_lf->next = new_lf;
    old_lf = new_lf;
  }
}



/* ////////////////////////////////////////////////////////////////////////////
////            lf_set                                                     ////
////            եξɤ߹                                   ////
//////////////////////////////////////////////////////////////////////////// */
void lf_set(argv_path)
    char    **argv_path;
{
    DIR * dp;
    char **wargv_path = argv_path;
    char *ptr, *fname, *ifname;
    struct direct *dir;
    struct group *gr, *getgrgid();
    struct passwd *pw, *getpwuid();
    struct stat buff;
    struct lf_stat *current_lf;
    int i, len, dirflag, wargc;
    static char *nullptr = "";
    int c;
    char buffer[256];

    size_total = 0;
    getwd(my_PWD);                            /* PWD */
    gethostname(my_Hname, sizeof(my_Hname));  /* Hostname */
    pw = getpwuid(getuid());                  /* User Id  */
    gr = getgrgid(getgid());                  /* Group Id */
    strcpy(my_Uid, pw->pw_name);
    strcpy(my_Gid, gr->gr_name);

    /*  ɸϤɤ߹  97.9.8 */
    if ( stdin_flag ) {
      i = 0;
      while( (c = getc(stdin)) != EOF ) {
	buffer[i++] = c;
	if ( c == '\n' ) {
	  buffer[--i] = '\0';
	  lf_set_stat(buffer);
	  i = 0;
	}
      }
      if ( nfile )
	goto jmp;
      else {
        fprintf(stderr, "file not found\n");
        printf("\x07");
        exit (4);
      }
    }

    /* ---------------  lf_stat set  -------------- */
    if ( refresh_flag ) {
      if ( seiki_flag ) {    /* ɽξƤɽ */
        strcpy(ipath, opath);
        seiki_flag = 0;
      }
    }

    if ( !seiki_flag ) {    /* ɽȤʤ */
      strcpy(opath, ipath);
      buff.st_mode = 0;
      stat(opath, &buff);

      if ( buff.st_mode & S_IFDIR ) {  /*  status is directory  */
        if ( chdir(opath)) {
          fprintf(stderr, "cannot change directory : %s\n", opath);
          exit (4);
        }
        ifname = nullptr;
      } else {
        if ((ptr = strrchr(opath, '/'))) { /* directory/file */
          *ptr = 0;
          ifname = ptr + 1;

          if ( chdir(opath)) {
            fprintf(stderr, "cannot change directory : %s\n", opath);
            exit (4);
          }
        } else
          ifname = opath;
      }

      if ( !(dp = opendir("."))) {
        fprintf(stderr, "cannot open directory : %s\n", opath);
        exit (4);
      }

      while ((dir = readdir(dp))) {
        if ( dir->d_ino == 0 || !strstr(dir->d_name, ifname))
          continue;
        lf_set_stat(dir->d_name);
      }
      closedir(dp);
    } else { /*  ɽ  */
      wargv_path = argv_path;
      dirflag = 0;
      if ((ptr = strrchr(*wargv_path, '/'))) {
        len = ptr - *wargv_path;
        *ptr = 0;
        dirflag = 1;

        if ( chdir(*wargv_path) ) {
          fprintf(stderr, "cannot chenge directory : %s\n", *wargv_path);
          exit (4);
        }
      }
      while ( *wargv_path ) {
        if ( dirflag )
          fname = *wargv_path + len + 1;
        else
          fname = *wargv_path;
        wargv_path++;
        lf_set_stat(fname);
      }
    }

    if ( !nfile ) {
        fprintf(stderr, "file not found\n");
        printf("\x07");
        exit (4);
    }

  jmp:
    /* --------------  lf_stat pointer set  -------------- */
    if ( !(pfile = calloc(nfile, sizeof(char **)))) {
        fprintf(stderr, "<<<  Out of Memory  (pfile) >>>\n");
        exit (4);
    }

    if ( !(spt = calloc(nfile, sizeof(int *)))) {
        fprintf(stderr, "<<<  Out of Memory  (spt) >>>\n");
        exit (4);
    }

    current_lf = first_lf;
    for ( i = 0 ; i < nfile ; i++ ) {
        pfile[i] = (char *)current_lf;
        spt[i] = i;
        current_lf = current_lf->next;
    }

    if ( !(Ucmd_area = calloc(1, UCMD_BUFFER))) {
        fprintf(stderr, "<<<  Out of Memory  (Ucmd_area) >>>\n");
        exit (4);
    }
    Ucmd_unuse = Ucmd_area;  /* Ucmd_area ̤ΰΥݥ󥿡 */

    getwd(opath);      /*  PWD  */
}
