#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <pwd.h>
#include <grp.h>
#include <time.h>
#include "define.h"
#define NOT_X
#include "lf.h"
#undef NOT_X


/* ////////////////////////////////////////////////////////////////////////////
////            lf_set_tgz_stat                                            ////
////           tgz, lzh, zip ̴ؿ                                  ////
//////////////////////////////////////////////////////////////////////////// */
void lf_set_tgz_stat(buffer)
     char buffer[];
{
  struct lf_stat *current_lf;
  char *argv[8];
  char *ptr, *oldptr, *fname;
  mode_t  st_mode;
  time_t  st_time;
  struct tm t;
  div_t d;
  int day, i, flag;
  struct lf_stat *new_lf;
  static struct lf_stat *old_lf;
  static char *month_tbl[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
				"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

  ptr = buffer;
  for ( i = 0 ; i < 8 ; i++ ) {
    while ( *ptr == ' ' )	/*  ɤФ  */
      ptr++;
    argv[i] = ptr;
    ptr = strchr(ptr, ' ');
    *ptr++ = 0;
  }

  /*------------------------------  calloc  (lf_stat)  --------*/
  if ( !(new_lf = calloc(1, sizeof(struct lf_stat)))) {
    fprintf(stderr, "<<<  Out of Memory (lftgz) >>>\n");
    exit (4);
  }
    
  /*------------------------------  calloc  (fname)  ----------*/
  if ( !(new_lf->st_name = calloc(1, strlen(argv[7])+1))) {
    fprintf(stderr, "<<<  Out of Memory  (fname) >>>\n");
    exit (4);
  }

  /*  fname_over set  */
  i = strlen(argv[7]) - 27;
  if ( i > 0 ) {
    if ( fname_over < i )
      fname_over = i;
  }
  strcpy(new_lf->st_name, argv[7]);
  new_lf->st_size  = atoi(argv[2]);
    
  /*  permition  */
  if ( lzh_type ) {  /*  [MS-DOS] ... etc  */
    strcpy(lzh_permission_type, argv[0]);
  } else {
    st_mode = 0;
    for ( i = 1 ; i < 10 ; i++ ) {
      st_mode *= 2;
      if ( buffer[i] != '-' )
	st_mode += 1;
    }
    
    if ( buffer[3] == 's' )
      st_mode += S_ISUID;
    if ( buffer[6] == 's' )
      st_mode += S_ISGID;
    if ( buffer[9] == 't' )
      st_mode += S_ISVTX;
    
    if ( buffer[0] == 'd' )
      st_mode += S_IFDIR;
    else if ( buffer[0] == 'c' )
      st_mode += S_IFBLK;
    else if ( buffer[0] == 'b' )
      st_mode += S_IFREG;
    else if ( buffer[0] == 'l' )
      st_mode += S_IFLNK;
    else if ( buffer[0] == 's' )
      st_mode += S_IFSOCK;
    else if ( buffer[0] == 'p' )
      st_mode += S_IFIFO;
    else if ( buffer[0] == '-' )
      st_mode += S_IFREG;

    new_lf->st_mode  = st_mode;
  }

  /*  ॹ  */
  t.tm_year = -1900 + atoi(argv[6]);
  for ( i = 0 ; i < 12 ; i++ ) {
    if ( !strncmp(argv[3], month_tbl[i], 3))
      break;
  }
  t.tm_mon = i;

  t.tm_mday = atoi(argv[4]);
  t.tm_hour = atoi(argv[5]);
  t.tm_min = atoi(argv[5]+3);
  t.tm_sec = 0;
  t.tm_isdst = -1;		/*  ̵  */
  if ((st_time = mktime(&t)) == (time_t)-1 ) {
    fprintf(stderr, "mktime() failed\n");
    st_time = 0;
  }
  new_lf->st_mtime1 = st_time;

  /*    */
  ptr = strchr(argv[1], '/');
  *ptr = 0;
  flag = 0;
  for ( i = 0 ; i < ntgz_uid ; i++ ) { /*   uid򸡺  */
    if ( !strcmp(argv[1], tgz_uid[i])) {
      new_lf->st_uid = i;	/*  uid򥻥å  */
      flag = 1;
    }
  }
  if ( !flag ) {		/*  uidɲ  */
    if ( ntgz_uid > MAX_TGZ_UID ) {
      fprintf(stderr, "tgz_uid %d table over!\n", MAX_TGZ_UID);
      exit (4);
    }
    if ( !(tgz_uid[ntgz_uid] = calloc(1, strlen(argv[1])+1))) {
      fprintf(stderr, "<<<  Out of Memory (uid) >>>\n");
      exit (4);
    }
    strcpy(tgz_uid[ntgz_uid], argv[1]);
    new_lf->st_uid = ntgz_uid;	/*  uid򥻥å  */
    ntgz_uid++;
  }

  /*  롼  */
  ptr++;
  flag = 0;
  for ( i = 0 ; i < ntgz_gid ; i++ ) { /*   gid򸡺  */
    if ( !strcmp(ptr, tgz_gid[i])) {
      new_lf->st_gid = i;	/*  gid򥻥å  */
      flag = 1;
    }
  }
  if ( !flag ) {		/*  gidɲ  */
    if ( ntgz_gid > MAX_TGZ_GID ) {
      fprintf(stderr, "tgz_gid %d table over!\n", MAX_TGZ_GID);
      exit (4);
    }
    if ( !(tgz_gid[ntgz_gid] = calloc(1, strlen(ptr)+1))) {
      fprintf(stderr, "<<<  Out of Memory (gid) >>>\n");
      exit (4);
    }
    strcpy(tgz_gid[ntgz_gid], ptr);
    new_lf->st_gid = ntgz_gid;	/*  gid򥻥å  */
    ntgz_gid++;
  }

  new_lf->Mcmd = ' ';
  new_lf->Ucmd = NULL;
  new_lf->ersflag = '0';
  nfile++;

  /*    512 Block  */
  d = div(new_lf->st_size, 512);
  if ( d.rem )
    d.quot++;
  size_total += d.quot * 512;

  if ( first_lf == NULL ) {
    first_lf = new_lf;
    old_lf = new_lf;
  } else {
    old_lf->next = new_lf;
    old_lf = new_lf;
  }
}


/* ////////////////////////////////////////////////////////////////////////////
////            lf_set_tgz                                                 ////
////            .tar.gz եξɤ߹                           ////
//////////////////////////////////////////////////////////////////////////// */
void lf_set_tgz()
{
  FILE    *pfp;
  struct group *gr, *getgrgid();
  struct passwd *pw, *getpwuid();
  struct lf_stat *current_lf;
  char buffer[256], *argv[8];
  char *ptr, *oldptr, *fname;
  mode_t  st_mode;
  time_t  st_time;
  struct tm t;
  div_t d;
  int day, i, flag, ret, line_count;
  struct lf_stat *new_lf;
  static struct lf_stat *old_lf;
  static char *month_tbl[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
				"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
  static char *cmd[] = {"tar tvfz", "lha l", "unzip -l"};

  size_total = 0;
  getwd(my_PWD);		/* PWD */
  gethostname(my_Hname, sizeof(my_Hname)); /* Hostname */
  pw = getpwuid(getuid());	/* User Id  */
  gr = getgrgid(getgid());	/* Group Id */
  strcpy(my_Uid, pw->pw_name);
  strcpy(my_Gid, gr->gr_name);

  strcpy(opath, ipath);
  if ( ptr = strrchr(opath, '/')) { /* directory/file */
    *ptr = 0;
    fname = strrchr(ipath, '/') + 1;

    if ( chdir(opath)) {
      fprintf(stderr, "cannot change directory : %s\n", opath);
      exit (4);
    }
  } else
    fname = ipath;

  getwd(opath);			/* opath  */
  strcat(strcat(opath, "/"), fname);

  sprintf(buffer, "%s %s", cmd[tgz_flag-1], fname);
  pfp = popen(buffer, "r");

  line_count = 0;
  while( fgets(buffer, sizeof(buffer), pfp)) { 

    if ( tgz_flag == 1 )  /*  tgz  */
      buffer[strlen(buffer)-1] = ' ';	/*  \nˤ  */
    else if ( tgz_flag == 2 ) {  /*  lzh  */
      ret = lf_set_lzh2tgz(buffer, &line_count);
      if ( ret == 1 ) 
	continue;
      if ( ret == 4 ) 
	break;

    } else if ( tgz_flag == 3 ) {  /*  zip  */
      ret = lf_set_zip2tgz(buffer, &line_count);
      if ( ret == 1 ) 
	continue;
      if ( ret == 4 ) 
	break;
    }
    lf_set_tgz_stat(buffer);
  }
  pclose (pfp);

  /* --------------  lf_stat pointer set  -------------- */
  if ( !(pfile = calloc(nfile, sizeof(char **)))) {
    fprintf(stderr, "<<<  Out of Memory  (pfile) >>>\n");
    exit (4);
  }

  if ( !(spt = calloc(nfile, sizeof(int *)))) {
    fprintf(stderr, "<<<  Out of Memory  (spt) >>>\n");
    exit (4);
  }

  current_lf = first_lf;
  for ( i = 0 ; i < nfile ; i++ ) {
    pfile[i] = (char *)current_lf;
    spt[i] = i;
    current_lf = current_lf->next;
  }

  if ( !(Ucmd_area = calloc(1, UCMD_BUFFER))) {
    fprintf(stderr, "<<<  Out of Memory  (Ucmd_area) >>>\n");
    exit (4);
  }
  Ucmd_unuse = Ucmd_area;  /* Ucmd_area ̤ΰΥݥ󥿡 */

  /*  Ȥ /tmpѹ  */
  if ( chdir("/tmp")) {
    fprintf(stderr, "cannot change directory : %s\n", "/tmp");
    exit (4);
  }
}
