/*
@  Hex dump list 쐬
                                             1992/02/24
                                     Modify  1997/09/26

       Create by H.Fujita      PXU16067@niftyserve.or.jp
*/
#include <stdio.h>
#include <stdlib.h>

int code;  /*  0:normal 1:sjis 2:euci܂ǁj */

/* ////////////////////////////////////////////////////////////////////////////
////           iskana, iskanji, iskanji2                                   ////
//////////////////////////////////////////////////////////////////////////// */
int iskana(c)
    unsigned char    c;
{
    if ( 0xA1 <= c && c <= 0xDF ) return (1);
    return (0);
}

int iskanji(c)
    unsigned char    c;
{
    if ((0x81 <= c && c <= 0x9F) ||
/*      (0xE0 <= c && c <= 0xFC)) return (1);    96.9.19  modify  */
        (0xE0 <= c && c <= 0xEE)) return (1);
    return (0);
}

int iskanji2(c)
    unsigned char    c;
{
    if ( (0x40 <= c && c <= 0x7E) ||
         (0x80 <= c && c <= 0xFC) ) return (1);
    return (0);
}


/* ////////////////////////////////////////////////////////////////////////////
////           dumplist()                                                  ////
//////////////////////////////////////////////////////////////////////////// */
unsigned long int address;

void dumplist(fp)
    FILE *fp;
{
    unsigned char inbuf[20];
    int count, c;
    void dumplist_sub();

    address = count = 0;
    while ((c = getc(fp)) != EOF) {
        inbuf[count++] = c;
        if ( count == 16 ) {
            dumplist_sub(fp, inbuf, count);
            count = 0;
        }
    }
    if ( count ) {
        dumplist_sub(fp, inbuf, count);
    }
}

void dumplist_sub(fp, inbuf, count)
     FILE *fp;
     unsigned char inbuf[20];
     int count;
{
    unsigned char *c, outbuf[80];
    int i, j, ic;
    div_t result;
    static int flag = 0;

    inbuf[count] = 0;
    memset(outbuf, ' ', 80);
    sprintf(outbuf, "%8.8lX:", address);

    for ( i = 0, j = 9 ; i < count ; i++ ) {
        sprintf(outbuf+j, "%3.2X", inbuf[i]);
        outbuf[j+=3] = ' ';
        result = div(i+1, 4);
        if ( !result.rem )
            j++;
    }

    c = inbuf;
    for ( i = 0, j = 62 ; i < count ; i++, j++, c++ ) {
        if ( flag ) {
            flag = 0;
            continue;
        }

        if ( iscntrl(*c) ) {
            outbuf[j] = '.';
            continue;
        }

        if ( !(isprint(*c) || iskana(*c))) {
	  if ( code == 0 ) {
	    outbuf[j] = '.';
	  } else if ( code == 1 ) { 
            if ( iskanji(*c)) {
                if ( i == count-1 ) {
                    if ((ic = getc(fp)) == EOF)
                        continue;
                    ungetc(ic, fp);
                    inbuf[16] = ic;
                    flag = 1;
                }

                if ( iskanji2(inbuf[i+1])) {
                    outbuf[j++] = *c++;
                    outbuf[j] = inbuf[++i];
                } else {
                    flag = 0;
                    outbuf[j] = '.';
                }
            } else
                outbuf[j] = '.';
	  }
        } else
            outbuf[j] = *c;
    }
    outbuf[j] = 0;
    printf("%s\n", outbuf);
    address += 16;
}


/* ////////////////////////////////////////////////////////////////////////////
////           main                                                        ////
//////////////////////////////////////////////////////////////////////////// */
int main(argc, argv)
    int    argc;
    char   *argv[];
{
    FILE *fp;
    char **wargv = argv, **pt;
    int nargc = 0;

    while ( *++wargv ) {
        if ( strstr(*wargv, "-h")) {
            fprintf(stderr, "Usage: %s < [file] | [file]\n", argv[0]);
            fprintf(stderr, "       -s : sjis\n");
            exit (0);
        } else if ( !strcmp(*wargv, "-s"))
            code = 1;
        else
	    nargc++;
    }

    if ( nargc == 0 ) {  /*  W  */
        fp = stdin;
        dumplist(stdin);
    } else {             /*  t@C  */
        wargv = argv;
        while ( *++wargv ) {
	    if ( !strcmp(*wargv, "-s"))
		continue;
            if ( !(fp = fopen(*wargv, "rb"))) {
                fprintf(stderr, "\x07 Can't open file %s\n", *wargv);
                continue;
            }
            dumplist(fp);
            fclose(fp);
        }
    }
    exit (0);
}
