#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>  /*  MAXPATHLEN  */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "define.h"
#include "lf.h"

/* ////////////////////////////////////////////////////////////////////////////
////            scroll_up                                                  ////
//////////////////////////////////////////////////////////////////////////// */
void scroll_up()
{
    int     src_x, src_y, dest_x, dest_y;
    unsigned int    width, height;

    if ( color_flag )
	XSetPlaneMask(pDisplay, gc, ~ncgcolor);

    src_x = 0;
    src_y = nFontHeight * 2;
    width = uWidth;
    height = (dis_lines - 1) * nFontHeight;
    dest_x = 0;
    dest_y = nFontHeight * 3;
    XCopyArea(pDisplay, window, window, gc, src_x, src_y, width, height, dest_x, dest_y);

    if ( color_flag )
	XSetPlaneMask(pDisplay, gc, 0xffffffff);
}


/* ////////////////////////////////////////////////////////////////////////////
////            cursor_up                                                  ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_up()
{
    if ( dis_cursor == 0 ) {
        if ( dis_top ) {  /*  ̥  */
	    if ( !color_flag )
		EraseBoxCursor(curxx, curyy);
            dis_top--;
            selfile--;
            scroll_up();
            ClearTextArea(0, curyy, 80+fname_over);
            lf_draw_file(selfile, curyy);
        } else
            return;
    } else {              /*  륢å  */
        selfile--;
        curyy--;
        dis_cursor--;
    }
    cursor_xx(1);
    select_file_box_no();
    TextCursor(curxx, curyy);
}


/* ////////////////////////////////////////////////////////////////////////////
////            cursor_top                                                 ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_top()
{
    if ( !dis_cursor ) {  /*  ̤ɽ  */
        if ( dis_top ) {
            dis_top -= dis_lines;
            if ( dis_top < 0 )
                dis_top = 0;
            lf_draw();
        }
    } else {              /*  ̤κǾʤذư  */
        selfile -= dis_cursor;
        curyy -= dis_cursor;
        dis_cursor = 0;
        cursor_xx(1);
        select_file_box_no();
        TextCursor(curxx, curyy);
    }
}

/* ////////////////////////////////////////////////////////////////////////////
////            scroll_down                                                ////
//////////////////////////////////////////////////////////////////////////// */
void scroll_down()
{
    int     src_x, src_y, dest_x, dest_y;
    unsigned int    width, height;

    if ( color_flag )
	XSetPlaneMask(pDisplay, gc, ~ncgcolor);

    src_x = 0;
    src_y = nFontHeight * 3;
    width = uWidth;
    height = (dis_lines - 1) * nFontHeight;
    dest_x = 0;
    dest_y = nFontHeight * 2;
    XCopyArea(pDisplay, window, window, gc, src_x, src_y, width, height, dest_x, dest_y);

    if ( color_flag )
	XSetPlaneMask(pDisplay, gc, 0xffffffff);
}


/* ////////////////////////////////////////////////////////////////////////////
////            cursor_down                                                ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_down(int flag)
{
    dis_bottom = dis_top + dis_lines - 1;
    if ( dis_bottom > nfile - 1)
        dis_bottom = nfile - 1;

    if ( selfile == dis_bottom ) {
        if ( (dis_top + dis_lines) < nfile ) {  /*  ̥  */
	    if ( !color_flag )
		EraseBoxCursor(curxx, curyy);
            dis_top++;
            selfile++;
            scroll_down();
            ClearTextArea(0, curyy, 80+fname_over);
            lf_draw_file(selfile, curyy);
        }/* else
            return;*/
    } else {                                    /*    */
        selfile++;
        curyy++;
        dis_cursor++;
    }
    cursor_xx(flag);
    select_file_box_no();
    TextCursor(curxx, curyy);
}


/* ////////////////////////////////////////////////////////////////////////////
////            cursor_bottom                                              ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_bottom()
{
    int     i;

    dis_bottom = dis_top + dis_lines;
    if ( dis_bottom > nfile )
        dis_bottom = nfile;

    if ( selfile == dis_bottom - 1 ) {  /*  ̤ɽ  */
        if ( (dis_top + dis_lines) < nfile ) {
            dis_top += dis_lines;
            lf_draw();
        }
    } else {                            /*  ̤κǲʤذư  */
        i = dis_bottom - dis_top - dis_cursor - 1;
        dis_cursor += i;
        selfile += i;
        curyy += i;
        cursor_xx(1);
        select_file_box_no();
        TextCursor(curxx, curyy);
    }
}


/* ////////////////////////////////////////////////////////////////////////////
////            backspacekey                                               ////
//////////////////////////////////////////////////////////////////////////// */
void backspacekey()
{
    int     n, xx;
    char    *ptr;
    struct  lf_stat  *current_lf;

    if ( cmode == M_COMMAND || !pkey )
        return;

    current_lf = (struct lf_stat *)pfile[spt[selfile]];
    ptr = current_lf->Ucmd + pkey;
/*    strcpy(ptr-1, ptr);*/
    Ucmd_move(ptr-1, ptr, Ucmd_unuse - ptr, -1);

    if ( pkey-1 == strlen(current_lf->Ucmd))
        n = 0;
    else
        n = 1;

    xx = strlen(current_lf->st_name) + 3 + --pkey;
    CopyPlaneArea(xx+1, curyy, xx, curyy, strlen(ptr)+1);
    ClearPlaneArea(xx+strlen(ptr)+n, curyy, 1);
    TextCursor(--curxx, curyy);
    Ucurrent_pkey = pkey;
}


/* ////////////////////////////////////////////////////////////////////////////
////            deletekey                                                  ////
//////////////////////////////////////////////////////////////////////////// */
void deletekey()
{
    int     xx;
    char    *ptr;
    struct  lf_stat  *current_lf;

    if ( cmode == M_COMMAND )
        return;
    current_lf = (struct lf_stat *)pfile[spt[selfile]];
    ptr = current_lf->Ucmd;
    if ( strlen(ptr) == pkey)
        return;

    ptr += pkey;
/*    strcpy(ptr, ptr+1);*/
    Ucmd_move(ptr, ptr+1, Ucmd_unuse - ptr - 1, -1);

    xx = strlen(current_lf->st_name) + 3 + pkey;
    CopyPlaneArea(xx+1, curyy, xx, curyy, strlen(ptr));
    ClearPlaneArea(xx+strlen(ptr), curyy, 1);

    if ( !color_flag )
	TextCursor(curxx, curyy);  /* 97/5/6 */
}


/* ////////////////////////////////////////////////////////////////////////////
////            insertkey                                                  ////
//////////////////////////////////////////////////////////////////////////// */
void insertkey()
{
    int     xx;
    char    *ptr;
    struct  lf_stat  *current_lf;

    current_lf = (struct lf_stat *)pfile[spt[selfile]];
    if ( current_lf->ersflag == '1' )
        goto jmp;

    if ( !current_lf->Ucmd ) {
      current_lf->Ucmd = Ucmd_unuse;
      Ucmd_unuse++;
    }

    ptr = current_lf->Ucmd + pkey;
    xx = strlen(current_lf->st_name) + 3 + pkey;
    if ( insert_flag )
      CopyPlaneArea(xx, curyy, xx+1, curyy, strlen(ptr));

    if ( insert_flag || *(ptr) == 0 ) 
      Ucmd_move(ptr+1, ptr, Ucmd_unuse - ptr, 1);

    *ptr = buffer[0];
    Ucurrent_pkey = ++pkey;
    curxx++;

    /*  check program  */
#ifdef DEBUG
    Ucmd_area_debug();
#endif

    TextCursor(curxx, curyy);
    if ( color_flag )
	XSetPlaneMask (pDisplay, gc, nbgcolor|ntgcolor|negcolor);

    XSetForeground(pDisplay, gc, ntgcolor);
    XSetBackground(pDisplay, gc, nbgcolor);
    DrawImageText (xx, curyy, buffer, 1, 0);
    if ( color_flag )
	XSetPlaneMask (pDisplay, gc, 0xffffffff);
    else
	TextCursor(curxx, curyy);  /* 97/5/6 */

  jmp:      /*  ᤬ '=' λϼιԤؿʤ  */
    if ( buffer[0] == '=' && pkey <= 1 )
        cursor_down(0);
}
