#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include "define.h"
#define NOT_X
#include "lf.h"
#undef NOT_X

/* ////////////////////////////////////////////////////////////////////////////
////            swap                                                       ////
//////////////////////////////////////////////////////////////////////////// */
void swap(a, b)
int     *a, *b;
{
    int     w;
    w  = *a;
    *a = *b;
    *b = w;
}


/* ////////////////////////////////////////////////////////////////////////////
////            shell_sort                                                 ////
//////////////////////////////////////////////////////////////////////////// */
void shell_sort(sort_key)
    int     sort_key;
{
    int     gap, i, j, k;
    char    *str1, *str2;
    char    *fname1, *fname2, *ptr;
    char    strA[256], strB[256], strW[256];
    struct  lf_stat  *current_lf_j, *current_lf_k;

    Msg_Run(True);
    gap = nfile / 2;
    while ( gap > 0 ) {
        for ( i = gap ; i < nfile ; i++) {
            j = i - gap;
            while ( j >= 0 ) {
                current_lf_j = (struct lf_stat *)pfile[spt[j]];
                k = j + gap;
                current_lf_k = (struct lf_stat *)pfile[spt[k]];
                fname1 = current_lf_j->st_name;
                fname2 = current_lf_k->st_name;

                switch (sort_key) {
                case SORT_NAME:          /* Name */
                    str1 = fname1;
                    str2 = fname2;
                    if ( sortflag_name )
                        swap(&str1, &str2);
                    break;

                case SORT_MODE:          /* Permition */
                    sprintf(strA, "%d%s", current_lf_j->st_mode, fname1);
                    sprintf(strB, "%d%s", current_lf_k->st_mode, fname2);
                    str1 = strA;
                    str2 = strB;
                    if ( sortflag_mode )
                        swap(&str1, &str2);
                    break;

                case SORT_SIZE:          /* Size */
                    sprintf(strA, "%9ld%s", current_lf_j->st_size, fname1);
                    sprintf(strB, "%9ld%s", current_lf_k->st_size, fname2);
                    str1 = strA;
                    str2 = strB;
                    if ( sortflag_size )
                        swap(&str1, &str2);
                    break;

                case SORT_OWNER:         /* Owner */
                    sprintf(strA, "%d%d%s", current_lf_j->st_uid,
                            current_lf_j->st_gid, fname1);
                    sprintf(strB, "%d%d%s", current_lf_k->st_uid,
                            current_lf_k->st_gid, fname2);
                    str1 = strA;
                    str2 = strB;
                    if ( sortflag_owner )
                        swap(&str1, &str2);
                    break;

                case SORT_DATE:          /* Date */
                    sprintf(strA, "%d%s", current_lf_j->st_mtime1, fname1);
                    sprintf(strB, "%d%s", current_lf_k->st_mtime1, fname2);
                    str1 = strA;
                    str2 = strB;
                    if ( sortflag_date )
                        swap(&str1, &str2);
                    break;

                case SORT_DOTT:         /* .name */
                    strcpy(strW, fname1);
                    if ( (ptr = strrchr(strW, '.'))) {
                        strcpy(strA, ptr);
                        strcat(strA, strW);
                    } else
                        strcpy(strA, strW);

                    strcpy(strW, fname2);
                    if ( (ptr = strrchr(strW, '.'))) {
                        strcpy(strB, ptr);
                        strcat(strB, strW);
                    } else
                        strcpy(strB, strW);

                    str1 = strA;
                    str2 = strB;
                    if ( sortflag_dott )
                        swap(&str1, &str2);
                    break;

                case SORT_LINK:         /* Link */
                    sprintf(strA, "%3d%s", current_lf_j->st_nlink, fname1);
                    sprintf(strB, "%3d%s", current_lf_k->st_nlink, fname2);
                    str1 = strA;
                    str2 = strB;
                    if ( sortflag_link )
                        swap(&str1, &str2);
                    break;
                default:
                    break;
                }

                if ( strcmp( str1 , str2 ) < 0 )
                    break;
                swap(&spt[j], &spt[k]);
                j -= gap;
            }
        }
        gap = gap / 2;
    }
    lf_draw();
    Msg_Run(False);
}
